## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

Name:           fmidi
Version:        0.1.1
%global so_version 0.1
Release:        %autorelease
Summary:        A library to read and play back MIDI files

License:        Boost
URL:            https://github.com/jpcima/%{name}
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

# Accepted PR to add man pages: https://github.com/jpcima/fmidi/pull/4
Patch0:         https://github.com/jpcima/fmidi/pull/4.patch

BuildRequires:  cmake
BuildRequires:  gcc-c++
# This is our choice; the makefile backend would work fine too
BuildRequires:  ninja-build

BuildRequires:  boost-devel
BuildRequires:  libev-devel
BuildRequires:  ncurses-devel
BuildRequires:  pkgconfig(rtmidi)
BuildRequires:  pkgconfig(fmt)

%global common_description %{expand:
Fmidi is a library to read and play back MIDI files. It supports both standard
MIDI files and RIFF MIDI files.

The functionality is exposed as a C programming interface, and it is
implemented with C++.

It is a simple library which is good for implementing a MIDI file player, or
any program taking MIDI files as inputs. In fact, a player with a terminal
interface is provided as an example.}

%description %{common_description}


%package tools
Summary:        Command-line tools based on the %{name} library
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description tools %{common_description}

The %{name}-tools package contains command-line tools based on the %{name} library.


%package libs
Summary:        Libraries for %{name}

%description libs %{common_description}

The %{name}-libs package contains the %{name} libraries.


%package devel
Summary:        Development files for %{name}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%autosetup -p1
# Fix library installation paths to match Fedora’s multilib layout. This is a
# quick and dirty patch; I don’t know the “right” way to do this with CMake, so
# I haven’t asked upstream to change anything.
sed -r -i \
    -e 's|"lib(["/])|"%{_libdir}\1|g' \
    -e 's|\\\$\{prefix\}/lib\b|%{_libdir}|g' \
    CMakeLists.txt


%build
%cmake \
    -DFMIDI_ENABLE_DEBUG=OFF \
    -DFMIDI_PIC=ON \
    -DFMIDI_STATIC=OFF \
    -GNinja
%cmake_build


%install
%cmake_install


# The base package has no %%files; there is no “fmidi” binary RPM


%check
# Upstream does not provide any tests.


%files tools
%{_bindir}/%{name}-convert
%{_bindir}/%{name}-grep
%{_bindir}/%{name}-play
%{_bindir}/%{name}-read
%{_bindir}/%{name}-seq

%{_mandir}/man1/%{name}-convert.1*
%{_mandir}/man1/%{name}-grep.1*
%{_mandir}/man1/%{name}-play.1*
%{_mandir}/man1/%{name}-read.1*
%{_mandir}/man1/%{name}-seq.1*


%files libs
%license LICENSE.md
%{_libdir}/lib%{name}.so.%{so_version}


%files devel
%doc README.md
%{_includedir}/%{name}.h
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc


%changelog
* Wed Aug 18 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.1-1
- Initial package
